﻿/*
 * Created by SharpDevelop.
 * User: pjohnson
 * Date: 22/02/2010
 * Time: 15:04
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections;
using System.Net.Sockets;
using System.Net.Security;

namespace email_to_paul_winform
{
	/// <summary>
	/// Description of pop3.
	/// </summary>
	public class pop3
	{
		public pop3()
		{
		}
		
		public class Pop3Exception : System. ApplicationException
		{
    		public Pop3Exception( string str) : base( str)
    		{
    		}
		}
	
		public class Pop3Message
		{
    		public long number;
    		public long bytes;
    		public bool retrieved;
    		public string message;
		}
		
		SslStream nstream;
		
		public SslStream Connect(string server, string username, string password)
		{
    		string message;
    		string response;
    		TcpClient tcpClient = new TcpClient();
    		tcpClient.Connect(server, 995);
    		nstream = new SslStream(tcpClient.GetStream());
    		nstream.AuthenticateAsClient("pop.gmail.com");
    		response = Response(nstream);
    		if (response.Substring(0, 3) != "+OK")
    		{
        		throw new Pop3Exception(response);
    		}

   			message = "USER " + username + "\r\n";
    		Write(message, nstream);
    		response = Response(nstream);
    		if (response.Substring(0, 3) != "+OK")
    		{
        		throw new Pop3Exception(response);
    		}

   			message = "PASS " + password + "\r\n";
    		Write(message, nstream);
    		response = Response(nstream);
    		if (response.Substring(0, 3) != "+OK")
    		{
        		throw new Pop3Exception(response);
   			}
    		return nstream;
		}
		
		public void Disconnect(SslStream netstream)
		{
    		string message;
    		string response;
    		message = "QUIT\r\n";
    		Write(message, netstream);
    		response = Response(netstream);
   			if (response.Substring(0, 3) != "+OK")
    		{
        		throw new Pop3Exception(response);
    		}
		}
		
		public ArrayList List(SslStream netstream)
		{
    		string message;
    		string response;

    		ArrayList retval = new ArrayList();
    		message = "LIST\r\n";
    		Write(message, netstream);
    		response = Response(netstream);
    		if (response.Substring(0, 3) != "+OK")
    		{
    		    throw new Pop3Exception(response);
    		}

   			while (true)
    		{
        		response = Response(netstream);
        		if (response == ".\r\n")
        		{
        		    return retval;
        		}
        		else
        		{
            		Pop3Message msg = new Pop3Message();
            		char[] seps = { ' ' };
            		string[] values = response.Split(seps);
            		msg.number = Int32.Parse(values[0]);
            		msg.bytes = Int32.Parse(values[1]);
            		msg.retrieved = false;
            		retval.Add(msg);
            		continue;
       			}
    		}
		}
		
		public Pop3Message Retrieve(Pop3Message rhs, SslStream netstream)
		{
    		string message;
    		string response;
    		string from, subject;
    		bool sf = true;
    		bool ss = true;
    		from = "";
    		subject = "";

    		Pop3Message msg = new Pop3Message();
    		msg.bytes = rhs.bytes;
    		msg.number = rhs.number;

    		message = "RETR " + rhs.number + "\r\n";
    		Write(message, netstream);
    		response = Response(netstream);
    		if (response.Substring(0, 3) != "+OK")
    		{
        		throw new Pop3Exception(response);
    		}

    		msg.retrieved = true;
    		while (true)
    		{
    			response = Response(netstream);
    			if (response.Contains("From:") == true)
    			{
    				from = response;
    				sf = false;
    			}
    			if (response.Contains("Subject:") == true)
    			{
    				subject = response;
    				ss = false;
    			}
    			if (response == ".\r\n")
    				break;
    		}
    		
    		if (ss == false && sf == false)
    		{
    			msg.message = from + " : " + subject;
    		}
    		
    		return msg;
		}
		
		public void Delete(Pop3Message rhs, SslStream netstream)
		{
    		string message;
    		string response;

    		message = "DELE " + rhs.number + "\r\n";
    		Write(message, netstream);
    		response = Response(netstream);
    		if (response.Substring(0, 3) != "+OK")
    		{
        		throw new Pop3Exception(response);
    		}
		}
		
		private void Write(string message, SslStream nstream)
		{
    		System.Text.ASCIIEncoding en = new System.Text.ASCIIEncoding() ;

    		byte[] WriteBuffer = new byte[1024] ;
    		WriteBuffer = en.GetBytes(message) ;
			nstream.Write(WriteBuffer, 0, WriteBuffer.Length);
		}
		
		private string Response(SslStream stream)
		{
    		System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
    		byte[] serverbuff = new Byte[1024];
    		int count = 0;
    		while (true)
    		{
        		byte[] buff = new Byte[2];
        		int bytes = stream.Read(buff, 0, 1 );
        		if (bytes == 1)
        		{
            		serverbuff[count] = buff[0];
            		count++;

            		if (buff[0] == '\n')
            		{
                		break;
            		}
        		}
        		else
        		{
           			break;
        		};
    		};

    	string retval = enc.GetString(serverbuff, 0, count );
    	return retval;
		}
	}
}
